From: Dorota Czaplejewicz <gihuac.dcz@porcupinefactory.org>
Date: Sun, 7 Feb 2021 13:01:34 +0000
Subject: s5k3l6xx: Use a dedicated structure to store register files

Having them as an array of ints is just too error-prone.
---
 drivers/media/i2c/s5k3l6xx.c | 393 ++++++++++++++++++++++---------------------
 1 file changed, 200 insertions(+), 193 deletions(-)

diff --git a/drivers/media/i2c/s5k3l6xx.c b/drivers/media/i2c/s5k3l6xx.c
index c60210a..f06db36 100644
--- a/drivers/media/i2c/s5k3l6xx.c
+++ b/drivers/media/i2c/s5k3l6xx.c
@@ -239,210 +239,217 @@ static const char * const s5k5baf_supply_names[] = {
 #define S5K5BAF_NUM_SUPPLIES 1
 // #define S5K5BAF_NUM_SUPPLIES ARRAY_SIZE(s5k5baf_supply_names)
 
+struct s5k3l6_reg {
+	u16 address;
+	u16 val;
+	// Size of a single write.
+	u8 size;
+};
+
 
-static const u16 sensor_3l6_pllinfo_A_4128x3096_30fps[] = {
+static const struct s5k3l6_reg sensor_3l6_pllinfo_A_4128x3096_30fps[] = {
        // EXT_CLK_Mhz * 1000 * 1000, /* ext_clk */
-       0x0301, 0x02, 0x01, /* vt_pix_clk_div   (0x0301) */
-       0x0303, 0x01, 0x01, /* vt_sys_clk_div   (0x0303) */ // not in doc!
-       0x0305, 0x03, 0x01, /* pre_pll_clk_div  (0x0305) */
-       0x0307, 0x53, 0x01, /* pll_multiplier   (0x0307) */
-       0x0309, 0x08, 0x01, /* op_pix_clk_div   (0x0309) */
-       0x030b, 0x01, 0x01, /* op_sys_clk_div   (0x030B) */
+       { 0x0301, 0x02, 0x01 }, /* vt_pix_clk_div   (0x0301) */
+       { 0x0303, 0x01, 0x01 }, /* vt_sys_clk_div   (0x0303) */ // not in doc!
+       { 0x0305, 0x03, 0x01 }, /* pre_pll_clk_div  (0x0305) */
+       { 0x0307, 0x53, 0x01 }, /* pll_multiplier   (0x0307) */
+       { 0x0309, 0x08, 0x01 }, /* op_pix_clk_div   (0x0309) */
+       { 0x030b, 0x01, 0x01 }, /* op_sys_clk_div   (0x030B) */
 
-       0x030d, 0x04, 0x01, /* secnd_pre_pll_clk_div    (0x030D) */
-       0x030f, 0x5C, 0x01, /* secnd_pll_multiplier     (0x030F) */
+       { 0x030d, 0x04, 0x01 }, /* secnd_pre_pll_clk_div    (0x030D) */
+       { 0x030f, 0x5C, 0x01 }, /* secnd_pll_multiplier     (0x030F) */
 
 	// WARNING: don't just copy, those are 2-bytes and the comment is about the high byte
-       0x0340, 0x0CC1, 0x02, /* frame_length_lines     (0x0341) */
-       0x0342, 0x1320, 0x02,/* line_length_pck (0x0343) */
+       { 0x0340, 0x0CC1, 0x02 }, /* frame_length_lines     (0x0341) */
+       { 0x0342, 0x1320, 0x02 }, /* line_length_pck (0x0343) */
 };
 
-static const u16 sensor_3l6_pllinfo_B_2064x1160_30fps[] = {
+static const struct s5k3l6_reg  sensor_3l6_pllinfo_B_2064x1160_30fps[] = {
 	// EXT_CLK_Mhz * 1000 * 1000, /* ext_clk */
-	0x0301, 0x02, 0x01, /* vt_pix_clk_div	(0x0301) */
-	0x0303, 0x01, 0x01, /* vt_sys_clk_div	(0x0303) */
-	0x0305, 0x03, 0x01, /* pre_pll_clk_div	(0x0305) */
-	0x0307, 0x53, 0x01, /* pll_multiplier	(0x0307) */
-	0x0309, 0x08, 0x01, /* op_pix_clk_div	(0x0309) */
-	0x030b, 0x04, 0x01, /* op_sys_clk_div	(0x030B) */
-
-	0x030d, 0x04, 0x01, /* secnd_pre_pll_clk_div	(0x030D) */
-	0x030f, 0x5C, 0x01, /* secnd_pll_multiplier	(0x030F) */
-	0x0340, 0x0CC1, 0x02, /* frame_length_lines	(0x0341) */
-	0x0342, 0x1320, 0x02, /* line_length_pck	(0x0343) */
+	{ 0x0301, 0x02, 0x01 }, /* vt_pix_clk_div	(0x0301) */
+	{ 0x0303, 0x01, 0x01 }, /* vt_sys_clk_div	(0x0303) */
+	{ 0x0305, 0x03, 0x01 }, /* pre_pll_clk_div	(0x0305) */
+	{ 0x0307, 0x53, 0x01 }, /* pll_multiplier	(0x0307) */
+	{ 0x0309, 0x08, 0x01 }, /* op_pix_clk_div	(0x0309) */
+	{ 0x030b, 0x04, 0x01 }, /* op_sys_clk_div	(0x030B) */
+
+	{ 0x030d, 0x04, 0x01 }, /* secnd_pre_pll_clk_div	(0x030D) */
+	{ 0x030f, 0x5C, 0x01 }, /* secnd_pll_multiplier	(0x030F) */
+	{ 0x0340, 0x0CC1, 0x02 }, /* frame_length_lines	(0x0341) */
+	{ 0x0342, 0x1320, 0x02 }, /* line_length_pck	(0x0343) */
 };
 
 
-static const u16 sensor_3l6_setfile_A_4128x3096_30fps[] = {
-       //mode change   Single Still Capture (4:3)
-       0x314A, 0x5F00, 0x02,
-       0x3064, 0xFFCF, 0x02,
-       0x3066, 0x7E00, 0x02,
-       0x309C, 0x0640, 0x02,
-       0x380C, 0x001A, 0x02,
-       0x32B2, 0x0000, 0x02,
-       0x32B4, 0x0000, 0x02,
-       0x32B6, 0x0000, 0x02,
-       0x32B8, 0x0000, 0x02,
-       0x3090, 0x8800, 0x02,
-       0x3238, 0x000C, 0x02,
-       0x0100, 0x0000, 0x02,
-       0x0344, 0x0030, 0x02,
-       0x0348, 0x104F, 0x02,
-       0x0346, 0x0014, 0x02,
-       0x034A, 0x0C2B, 0x02,
-       0x034C, 0x1020, 0x02,
-       0x034E, 0x0C18, 0x02,
-       0x0202, 0x03DE, 0x02,  // coarse_integration_time
-       0x3400, 0x0000, 0x02,
-       0x3402, 0x4E42, 0x02,
-       0x0136, 0x1A00, 0x02,
-       0x0304, 0x0003, 0x02,
-       0x0306, 0x0053, 0x02,
-       0x030C, 0x0004, 0x02,
-       0x030E, 0x005C, 0x02,
-       0x3C16, 0x0000, 0x02,
-       0x0342, 0x1320, 0x02,
-       0x0340, 0x0CC1, 0x02,
-       0x0900, 0x0000, 0x02,
-       0x0386, 0x0001, 0x02,
-       0x3452, 0x0000, 0x02,
-       0x345A, 0x0000, 0x02,
-       0x345C, 0x0000, 0x02,
-       0x345E, 0x0000, 0x02,
-       0x3460, 0x0000, 0x02,
-       0x38C4, 0x0009, 0x02,
-       0x38D8, 0x002A, 0x02,
-       0x38DA, 0x000A, 0x02,
-       0x38DC, 0x000B, 0x02,
-       0x38C2, 0x000A, 0x02,
-       0x38C0, 0x000F, 0x02,
-       0x38D6, 0x000A, 0x02,
-       0x38D4, 0x0009, 0x02,
-       0x38B0, 0x000F, 0x02,
-       0x3932, 0x1000, 0x02,
-       0x0820, 0x04AC, 0x02,
-       0x3C34, 0x0008, 0x02,
-       0x3C36, 0x2800, 0x02,
-       0x3C38, 0x0028, 0x02,
-       0x393E, 0x4000, 0x02,
+static const struct s5k3l6_reg  sensor_3l6_setfile_A_4128x3096_30fps[] = {
+       // mode change   Single Still Capture (4:3)
+       { 0x314A, 0x5F00, 0x02 },
+       { 0x3064, 0xFFCF, 0x02 },
+       { 0x3066, 0x7E00, 0x02 },
+       { 0x309C, 0x0640, 0x02 },
+       { 0x380C, 0x001A, 0x02 },
+       { 0x32B2, 0x0000, 0x02 },
+       { 0x32B4, 0x0000, 0x02 },
+       { 0x32B6, 0x0000, 0x02 },
+       { 0x32B8, 0x0000, 0x02 },
+       { 0x3090, 0x8800, 0x02 },
+       { 0x3238, 0x000C, 0x02 },
+       { 0x0100, 0x0000, 0x02 },
+       { 0x0344, 0x0030, 0x02 },
+       { 0x0348, 0x104F, 0x02 },
+       { 0x0346, 0x0014, 0x02 },
+       { 0x034A, 0x0C2B, 0x02 },
+       { 0x034C, 0x1020, 0x02 },
+       { 0x034E, 0x0C18, 0x02 },
+       { 0x0202, 0x03DE, 0x02 },  // coarse_integration_time
+       { 0x3400, 0x0000, 0x02 },
+       { 0x3402, 0x4E42, 0x02 },
+       { 0x0136, 0x1A00, 0x02 },
+       { 0x0304, 0x0003, 0x02 },
+       { 0x0306, 0x0053, 0x02 },
+       { 0x030C, 0x0004, 0x02 },
+       { 0x030E, 0x005C, 0x02 },
+       { 0x3C16, 0x0000, 0x02 },
+       { 0x0342, 0x1320, 0x02 },
+       { 0x0340, 0x0CC1, 0x02 },
+       { 0x0900, 0x0000, 0x02 },
+       { 0x0386, 0x0001, 0x02 },
+       { 0x3452, 0x0000, 0x02 },
+       { 0x345A, 0x0000, 0x02 },
+       { 0x345C, 0x0000, 0x02 },
+       { 0x345E, 0x0000, 0x02 },
+       { 0x3460, 0x0000, 0x02 },
+       { 0x38C4, 0x0009, 0x02 },
+       { 0x38D8, 0x002A, 0x02 },
+       { 0x38DA, 0x000A, 0x02 },
+       { 0x38DC, 0x000B, 0x02 },
+       { 0x38C2, 0x000A, 0x02 },
+       { 0x38C0, 0x000F, 0x02 },
+       { 0x38D6, 0x000A, 0x02 },
+       { 0x38D4, 0x0009, 0x02 },
+       { 0x38B0, 0x000F, 0x02 },
+       { 0x3932, 0x1000, 0x02 },
+       { 0x0820, 0x04AC, 0x02 },
+       { 0x3C34, 0x0008, 0x02 },
+       { 0x3C36, 0x2800, 0x02 },
+       { 0x3C38, 0x0028, 0x02 },
+       { 0x393E, 0x4000, 0x02 },
 	// the following not present in set B (otherwise identical)
-       0x3C1E, 0x0100, 0x02, // system pll pd (what does it mean? power down?)
-       0x0100, 0x0100, 0x02, // start streaming
-       0x3C1E, 0x0000, 0x02,
+	{ 0x3C1E, 0x0100, 0x02 }, // system pll pd (what does it mean? power down?)
+	{ 0x0100, 0x0100, 0x02 }, // start streaming
+       { 0x3C1E, 0x0000, 0x02 },
 };
 
-static const u16 sensor_3l6_setfile_B_2064x1160_30fps[] = {
+static const struct s5k3l6_reg sensor_3l6_setfile_B_2064x1160_30fps[] = {
 	/* VT Call 16:9 ratio */
-	0x314A, 0x5F02, 0x02,
-	0x3064, 0xFFCF, 0x02,
-	0x3066, 0x7E00, 0x02,
-	0x309C, 0x0640, 0x02,
-	0x380C, 0x0090, 0x02,
-	0x32B2, 0x0003, 0x02,
-	0x32B4, 0x0003, 0x02,
-	0x32B6, 0x0003, 0x02,
-	0x32B8, 0x0003, 0x02,
-	0x3090, 0x8000, 0x02,
-	0x3238, 0x000B, 0x02,
-	0x0100, 0x0000, 0x02, // stop stream
-	0x0344, 0x0030, 0x02, // x_addr_start
-	0x0348, 0x104F, 0x02, // x_addr_end
-	0x0346, 0x0198, 0x02, // y_addr_start
-	0x034A, 0x0AA7, 0x02, // y_addr_end
-	0x034C, 0x0810, 0x02, // x_output_size
-	0x034E, 0x0488, 0x02, // y_output_size
-	0x0202, 0x0656, 0x02, // coarse_integration_time
-	0x3400, 0x0000, 0x02, // can also be 0x1
-	0x3402, 0x4E46, 0x02,
+	{ 0x314A, 0x5F02, 0x02 },
+	{ 0x3064, 0xFFCF, 0x02 },
+	{ 0x3066, 0x7E00, 0x02 },
+	{ 0x309C, 0x0640, 0x02 },
+	{ 0x380C, 0x0090, 0x02 },
+	{ 0x32B2, 0x0003, 0x02 },
+	{ 0x32B4, 0x0003, 0x02 },
+	{ 0x32B6, 0x0003, 0x02 },
+	{ 0x32B8, 0x0003, 0x02 },
+	{ 0x3090, 0x8000, 0x02 },
+	{ 0x3238, 0x000B, 0x02 },
+	{ 0x0100, 0x0000, 0x02 }, // stop stream
+	{ 0x0344, 0x0030, 0x02 }, // x_addr_start
+	{ 0x0348, 0x104F, 0x02 }, // x_addr_end
+	{ 0x0346, 0x0198, 0x02 }, // y_addr_start
+	{ 0x034A, 0x0AA7, 0x02 }, // y_addr_end
+	{ 0x034C, 0x0810, 0x02 }, // x_output_size
+	{ 0x034E, 0x0488, 0x02 }, // y_output_size
+	{ 0x0202, 0x0656, 0x02 }, // coarse_integration_time
+	{ 0x3400, 0x0000, 0x02 }, // can also be 0x1
+	{ 0x3402, 0x4E46, 0x02 },
 	// This part actually covers the same as pllinfo.
-	0x0136, 0x1A00, 0x02, // extclk freq
-	0x0304, 0x0003, 0x02, // pre_pll_clk_div
-	0x0306, 0x0023, 0x02, // pll_multiplier
-	0x030C, 0x0004, 0x02, // op_pre_pll_clk_div
-	0x030E, 0x005C, 0x02, // op_pll_multiplier
+	{ 0x0136, 0x1A00, 0x02 }, // extclk freq
+	{ 0x0304, 0x0003, 0x02 }, // pre_pll_clk_div
+	{ 0x0306, 0x0023, 0x02 }, // pll_multiplier
+	{ 0x030C, 0x0004, 0x02 }, // op_pre_pll_clk_div
+	{ 0x030E, 0x005C, 0x02 }, // op_pll_multiplier
 	// not the next line
-	0x3C16, 0x0000, 0x02,
+	{ 0x3C16, 0x0000, 0x02 },
 	/// I don't get it, they are the same regardless of width. Frame length changes... with fps.
-	0x0342, 0x1320, 0x02, // line_length pixel clocks = 4896??? gives 2832 pixels of time of blanking
-	0x0340, 0x0CC1, 0x02, // frame_length_lines = 3265?? 2105 lines of blanking
+	{ 0x0342, 0x1320, 0x02 }, // line_length pixel clocks = 4896??? gives 2832 pixels of time of blanking
+	{ 0x0340, 0x0CC1, 0x02 }, // frame_length_lines = 3265?? 2105 lines of blanking
 	// presumes 480MHz pixel clock for 30fps
 	// end pllinfo part
-	//0x0900, 0x0122, 0x02, // binning enable, 2:2
-	//0x0386, 0x0003, 0x02, // y_odd_inc
-	0x0900, 0x0000, 0x02, // no binning (normal)
-
-	0x3452, 0x0000, 0x02,
-	0x345A, 0x0000, 0x02,
-	0x345C, 0x0000, 0x02,
-	0x345E, 0x0000, 0x02,
-	0x3460, 0x0000, 0x02,
-	0x38C4, 0x0009, 0x02,
-	0x38D8, 0x002A, 0x02,
-	0x38DA, 0x000A, 0x02,
-	0x38DC, 0x000B, 0x02,
-	0x38C2, 0x000A, 0x02,
-	0x38C0, 0x000F, 0x02,
-	0x38D6, 0x000A, 0x02,
-	0x38D4, 0x0009, 0x02,
-	0x38B0, 0x000F, 0x02,
-	0x3932, 0x1000, 0x02,
-	0x0820, 0x04AC, 0x02, // requested_link_rate freq of MIPI lane
-	0x3C34, 0x0008, 0x02,
-	0x3C36, 0x2800, 0x02,
-	0x3C38, 0x0028, 0x02,
-	0x393E, 0x4000, 0x02,
+	//{ 0x0900, 0x0122, 0x02 }, // binning enable, 2:2
+	//{ 0x0386, 0x0003, 0x02 }, // y_odd_inc
+	{ 0x0900, 0x0000, 0x02 }, // no binning (normal)
+
+	{ 0x3452, 0x0000, 0x02 },
+	{ 0x345A, 0x0000, 0x02 },
+	{ 0x345C, 0x0000, 0x02 },
+	{ 0x345E, 0x0000, 0x02 },
+	{ 0x3460, 0x0000, 0x02 },
+	{ 0x38C4, 0x0009, 0x02 },
+	{ 0x38D8, 0x002A, 0x02 },
+	{ 0x38DA, 0x000A, 0x02 },
+	{ 0x38DC, 0x000B, 0x02 },
+	{ 0x38C2, 0x000A, 0x02 },
+	{ 0x38C0, 0x000F, 0x02 },
+	{ 0x38D6, 0x000A, 0x02 },
+	{ 0x38D4, 0x0009, 0x02 },
+	{ 0x38B0, 0x000F, 0x02 },
+	{ 0x3932, 0x1000, 0x02 },
+	{ 0x0820, 0x04AC, 0x02 }, // requested_link_rate freq of MIPI lane
+	{ 0x3C34, 0x0008, 0x02 },
+	{ 0x3C36, 0x2800, 0x02 },
+	{ 0x3C38, 0x0028, 0x02 },
+	{ 0x393E, 0x4000, 0x02 },
 };
 
-static const u16 sensor_3l6_setfile_A_Global[] = {
+static const struct s5k3l6_reg sensor_3l6_setfile_A_Global[] = {
 	// None of this is in the documentation. Skip?
-       0x306A, 0x2F4C, 0x02,
-       0x306C, 0xCA01, 0x02,
-       0x307A, 0x0D20, 0x02,
-       0x309E, 0x002D, 0x02,
-       0x3072, 0x0013, 0x02,
-       0x3074, 0x0977, 0x02,
-       0x3076, 0x9411, 0x02,
-       0x3024, 0x0016, 0x02,
-       0x3002, 0x0E00, 0x02,
-       0x3006, 0x1000, 0x02,
-       0x300A, 0x0C00, 0x02,
-       0x3018, 0xC500, 0x02,
-       0x303A, 0x0204, 0x02,
-       0x3266, 0x0001, 0x02,
-       0x38DA, 0x000A, 0x02, // duplicated in resolution
-       0x38DC, 0x000B, 0x02, // and this
-       0x38D6, 0x000A, 0x02, // and this
-       0x3070, 0x3D00, 0x02,
-       0x3084, 0x1314, 0x02,
-       0x3086, 0x0CE7, 0x02,
-       0x3004, 0x0800, 0x02,
+       { 0x306A, 0x2F4C, 0x02 },
+       { 0x306C, 0xCA01, 0x02 },
+       { 0x307A, 0x0D20, 0x02 },
+       { 0x309E, 0x002D, 0x02 },
+       { 0x3072, 0x0013, 0x02 },
+       { 0x3074, 0x0977, 0x02 },
+       { 0x3076, 0x9411, 0x02 },
+       { 0x3024, 0x0016, 0x02 },
+       { 0x3002, 0x0E00, 0x02 },
+       { 0x3006, 0x1000, 0x02 },
+       { 0x300A, 0x0C00, 0x02 },
+       { 0x3018, 0xC500, 0x02 },
+       { 0x303A, 0x0204, 0x02 },
+       { 0x3266, 0x0001, 0x02 },
+       { 0x38DA, 0x000A, 0x02 }, // duplicated in resolution
+       { 0x38DC, 0x000B, 0x02 }, // and this
+       { 0x38D6, 0x000A, 0x02 }, // and this
+       { 0x3070, 0x3D00, 0x02 },
+       { 0x3084, 0x1314, 0x02 },
+       { 0x3086, 0x0CE7, 0x02 },
+       { 0x3004, 0x0800, 0x02 },
 };
 
-static const u16 sensor_3l6_setfile_B_Global[] = {
+static const struct s5k3l6_reg sensor_3l6_setfile_B_Global[] = {
 	// None of this is in the documentation. Skip?
-	0x306A,	0x2F4C, 0x02,
-	0x306C,	0xCA01, 0x02,
-	0x307A,	0x0D20, 0x02,
-	0x309E,	0x002D, 0x02,
-	0x3072,	0x0013, 0x02,
-	0x3074,	0x0977, 0x02,
-	0x3076,	0x9411, 0x02,
-	0x3024,	0x0016, 0x02,
-	0x3002,	0x0E00, 0x02,
-	0x3006,	0x1000, 0x02,
-	0x300A,	0x0C00, 0x02,
-	0x3018,	0xC500, 0x02,
-	0x303A,	0x0204, 0x02,
-	0x3266,	0x0001, 0x02,
-	0x38DA,	0x000E, 0x02, // different: 0x000a
-	0x38DC,	0x000B, 0x02,
-	0x38D6,	0x000A, 0x02,
-	0x3070,	0x3D00, 0x02,
-	0x3084,	0x1314, 0x02,
-	0x3086,	0x0CE7, 0x02,
-	0x3004,	0x0800, 0x02,
-	0x3C66,	0x0100, 0x02,	// Master mode disable ?? what is this even. Different than A
+	{ 0x306A,	0x2F4C, 0x02 },
+	{ 0x306C,	0xCA01, 0x02 },
+	{ 0x307A,	0x0D20, 0x02 },
+	{ 0x309E,	0x002D, 0x02 },
+	{ 0x3072,	0x0013, 0x02 },
+	{ 0x3074,	0x0977, 0x02 },
+	{ 0x3076,	0x9411, 0x02 },
+	{ 0x3024,	0x0016, 0x02 },
+	{ 0x3002,	0x0E00, 0x02 },
+	{ 0x3006,	0x1000, 0x02 },
+	{ 0x300A,	0x0C00, 0x02 },
+	{ 0x3018,	0xC500, 0x02 },
+	{ 0x303A,	0x0204, 0x02 },
+	{ 0x3266,	0x0001, 0x02 },
+	{ 0x38DA,	0x000E, 0x02 }, // different: 0x000a
+	{ 0x38DC,	0x000B, 0x02 },
+	{ 0x38D6,	0x000A, 0x02 },
+	{ 0x3070,	0x3D00, 0x02 },
+	{ 0x3084,	0x1314, 0x02 },
+	{ 0x3086,	0x0CE7, 0x02 },
+	{ 0x3004,	0x0800, 0x02 },
+	{ 0x3C66,	0x0100, 0x02 },	// Master mode disable ?? what is this even. Different than A
 };
 
 struct s5k5baf_gpio {
@@ -471,9 +478,9 @@ struct s5k3l6_frame {
 	u32 width;
 	u32 height;
 	u32 code;
-	const u16 *pllregs;
+	const struct s5k3l6_reg *pllregs;
 	u16 pllregcount;
-	const u16 *streamregs;
+	const struct s5k3l6_reg  *streamregs;
 	u16 streamregcount;
 };
 
@@ -572,17 +579,17 @@ static const struct s5k3l6_frame s5k3l6_frames[] = {
 	{
 		.width = 2064, .height = 1160,
 		.pllregs = sensor_3l6_pllinfo_B_2064x1160_30fps,
-		.pllregcount = ARRAY_SIZE(sensor_3l6_pllinfo_B_2064x1160_30fps) / 3,
+		.pllregcount = ARRAY_SIZE(sensor_3l6_pllinfo_B_2064x1160_30fps),
 		.streamregs = sensor_3l6_setfile_B_2064x1160_30fps,
-		.streamregcount = ARRAY_SIZE(sensor_3l6_setfile_B_2064x1160_30fps) / 3,
+		.streamregcount = ARRAY_SIZE(sensor_3l6_setfile_B_2064x1160_30fps),
 		.code = MEDIA_BUS_FMT_SBGGR8_1X8,
 	},
 	{
 		.width = 4128, .height = 3096,
 		.pllregs = sensor_3l6_pllinfo_A_4128x3096_30fps,
-		.pllregcount = ARRAY_SIZE(sensor_3l6_pllinfo_A_4128x3096_30fps) / 3,
+		.pllregcount = ARRAY_SIZE(sensor_3l6_pllinfo_A_4128x3096_30fps),
 		.streamregs = sensor_3l6_setfile_A_4128x3096_30fps,
-		.streamregcount = ARRAY_SIZE(sensor_3l6_setfile_A_4128x3096_30fps) / 3,
+		.streamregcount = ARRAY_SIZE(sensor_3l6_setfile_A_4128x3096_30fps),
 		.code = MEDIA_BUS_FMT_SBGGR8_1X8,
 	},
 };
@@ -688,13 +695,13 @@ static void s5k5baf_i2c_write2(struct s5k5baf *state, u16 addr, u16 val)
 	}
 }
 
-static void s5k3l6_submit_regs(struct s5k5baf *state, const u16 *regs, u16 regcount) {
+static void s5k3l6_submit_regs(struct s5k5baf *state, const struct s5k3l6_reg *regs, u16 regcount) {
        unsigned i;
-       for (i = 0; i < regcount; i+=3) {
-	       if (regs[i+2] == 2)
-		       s5k5baf_i2c_write2(state, regs[i], regs[i+1]);
+       for (i = 0; i < regcount; i++) {
+	       if (regs[i].size == 2)
+		       s5k5baf_i2c_write2(state, regs[i].address, regs[i].val);
 	       else
-		       s5k5baf_i2c_write(state, regs[i], (u8)regs[i+1]);
+		       s5k5baf_i2c_write(state, regs[i].address, (u8)regs[i].val);
        }
 }
 
@@ -775,13 +782,13 @@ static int s5k5baf_clear_error(struct s5k5baf *state)
 static int s5k3l6_hw_set_video_bus(struct s5k5baf *state)
 {
 	s5k3l6_submit_regs(state, sensor_3l6_setfile_A_Global,
-			   ARRAY_SIZE(sensor_3l6_setfile_A_Global) / 3);
+			   ARRAY_SIZE(sensor_3l6_setfile_A_Global));
 
 	return s5k5baf_clear_error(state);
 }*/
 
-static const u16 setstream[] = {
-	S5K3L6_REG_DATA_FORMAT, S5K3L6_DATA_FORMAT_RAW8, 2,
+static const struct s5k3l6_reg setstream[] = {
+	{ S5K3L6_REG_DATA_FORMAT, S5K3L6_DATA_FORMAT_RAW8, 2 },
 };
 
 static void s5k3l6_hw_set_config(struct s5k5baf *state) {
@@ -791,7 +798,7 @@ static void s5k3l6_hw_set_config(struct s5k5baf *state) {
 
 	// This may mess up PLL settings...
 	// If the above already enabled streaming (setfile A), we're also in trouble.
-	s5k3l6_submit_regs(state, setstream, ARRAY_SIZE(setstream) / 3);
+	s5k3l6_submit_regs(state, setstream, ARRAY_SIZE(setstream));
 }
 
 static void s5k3l6_hw_set_test_pattern(struct s5k5baf *state, int id)
